
Redmine - Patch #16319

Random crash when using custom fields

2014-03-11 15:55 - Felix Schäfer

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Jean-Philippe Lang % Done: 0%

Category: Code cleanup/refactoring Estimated time: 0.00 hour

Target version: 2.5.1   

Description

We (Planio) have seen several random crashes when using custom fields and have narrowed the problem to the usage of super to

access attribute setters and getters in ActiveRecord models. According the the ActiveRecord docs, the preferred way to set and get a

value from within a custom setter and getter is to use read_attribute and write_attribute.

Associated revisions

Revision 12968 - 2014-03-15 11:25 - Jean-Philippe Lang

Use #read/#write_attribute instead of #super when overwriting default accessors (#16319).

Patch by Felix Schäfer.

Revision 13024 - 2014-03-29 15:38 - Jean-Philippe Lang

Merged r12968 (#16319).

History

#1 - 2014-03-11 15:57 - Felix Schäfer

- File 16319.patch added

The attached patch changes the super calls in CustomField#possible_values and CustomField#possible_values= to read_attribute and

write_attribute.

#2 - 2014-03-11 21:46 - Etienne Massip

- Target version set to Candidate for next minor release

#3 - 2014-03-13 04:42 - Ebrahim Mohammadi

- File fix-crash.diff added

I experience some random crashed too. Isn't your problem the same as my problem which I worked around using the attached patch?

#4 - 2014-03-15 11:25 - Jean-Philippe Lang

- Category set to Code cleanup/refactoring

- Status changed from New to Resolved

- Assignee set to Jean-Philippe Lang

- Target version changed from Candidate for next minor release to 2.5.1

Patch applied in r12968, thanks.

#5 - 2014-03-29 15:38 - Jean-Philippe Lang

- Status changed from Resolved to Closed

Merged.

Files

16319.patch 884 Bytes 2014-03-11 Felix Schäfer

fix-crash.diff 689 Bytes 2014-03-13 Ebrahim Mohammadi
